'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildEnumValueConfigMap = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = buildEnum;

var _type = require('graphql/type');

var _buildASTSchema = require('graphql/utilities/buildASTSchema');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var buildEnumValueConfigMap = exports.buildEnumValueConfigMap = function buildEnumValueConfigMap(enumAST) {
  var configMap = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
  return enumAST.values.reduce(function (map, enumValueAST) {
    var name = enumValueAST.name.value;
    var config = configMap[name] || {};
    // set enum value to it's name by default
    var value = 'value' in config ? config.value : name;
    var description = (0, _buildASTSchema.getDescription)(enumValueAST);
    var enumValueConfig = { value: value };
    if ('deprecationReason' in config) enumValueConfig.deprecationReason = config.deprecationReason;
    if (description) enumValueConfig.description = description;
    return _extends({}, map, _defineProperty({}, name, enumValueConfig));
  }, {});
};

function buildEnum(enumAST) {
  var _ref = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var values = _ref.values;

  var enumTypeConfig = {
    name: enumAST.name.value,
    values: buildEnumValueConfigMap(enumAST, values)
  };
  var description = (0, _buildASTSchema.getDescription)(enumAST);
  if (description) enumTypeConfig.description = description;
  return new _type.GraphQLEnumType(enumTypeConfig);
}